# Class `wibox`

### Info:

- Copyright: 2010 Uli Schlachter
- Author: Uli Schlachter

## Functions

.wibox ([args=nil]) | Create a wibox.

## Object properties

wibox.border_width | Border width.
wibox.border_color | Border color.
wibox.ontop | On top of other windows.
wibox.cursor | The mouse cursor.
wibox.visible | Visibility.
wibox.opacity | The opacity of the wibox, between 0 and 1.
wibox.type | The window type (desktop, normal, dock, ...).
wibox.x | The x coordinates.
wibox.y | The y coordinates.
wibox.width | The width of the wibox.
wibox.height | The height of the wibox.
wibox.screen | The wibox screen.
wibox.drawable | The wibox's drawable.
wibox.widget | The widget that the wibox displays.
wibox.window | The X window id.
wibox.shape_bounding | The wibox's bounding shape as a (native) cairo surface.
wibox.shape_clip | The wibox's clip shape as a (native) cairo surface.
wibox.bg | The background of the wibox.
wibox.bgimage | The background image of the drawable.
wibox.fg | The foreground (text) of the wibox.

## Theme variables

beautiful.bg_normal | The default background color.
beautiful.fg_normal | The default foreground (text) color.

## Methods

wibox:buttons (buttons_table) | Get or set mouse buttons bindings to a wibox.
wibox:geometry (A) | Get or set wibox geometry.
wibox:struts (strut) | Get or set wibox struts.
wibox:setup (args) | Set a declarative widget hierarchy description.
wibox:find_widgets (x, y) | Find a widget by a point.
wibox:draw (wibox) | Redraw a wibox.

## Functions

Methods

.wibox ([args=nil])
  Create a wibox.
  - args
    - border_width integer Border width.
    - border_color string Border color.
    - ontop boolean On top of other windows.
    - cursor string The mouse cursor.
    - visible boolean Visibility.
    - opacity number The opacity of the wibox, between 0 and 1.
    - type string The window type (desktop, normal, dock, …).
    - x integer The x coordinates.
    - y integer The y coordinates.
    - width integer The width of the wibox.
    - height integer The height of the wibox.
    - screen screen The wibox screen.
    - widget wibox.widget The widget that the wibox displays.
    - shape_bounding The wibox’s bounding shape as a (native) cairo surface.
    - shape_clip The wibox’s clip shape as a (native) cairo surface.
    - bg color The background of the wibox.
    - bgimage surface The background image of the drawable.
    - fg color The foreground (text) of the wibox.

  ### Returns:

  wibox The new wibox

## Object properties

wibox.border_width

  Border width.

  Signal:

  - *property::border_width*

  ### Type:

  - integer
wibox.border_color

  Border color.

  Please note that this property only support string based 24 bit or 32 bit colors:

      Red Blue
       _|  _|
      #FF00FF
         T‾
       Green

      Red Blue
       _|  _|
      #FF00FF00
         T‾  ‾T
      Green   Alpha

  Signal:

  - *property::border_color*

  ### Type:

  - string
wibox.ontop

  On top of other windows.

  Signal:

  - property::ontop

  ### Type:

  - boolean
wibox.cursor

  The mouse cursor.

  Signal:

  - property::cursor

  ### Type:

  - string

  ### See also:

  mouse
wibox.visible

  Visibility.

  Signal:

  - property::visible

  ### Type:

  - boolean
wibox.opacity

  The opacity of the wibox, between 0 and 1.

  Signal:

  - property::opacity

  ### Type:

  - opacity number (between 0 and 1)
wibox.type

  The window type (desktop, normal, dock, ...).

  Signal:

  - property::type

  ### Type:

  - string

  ### See also:

  client.type
wibox.x

  The x coordinates.

  Signal:

  - property::x

  ### Type:

  - integer
wibox.y

  The y coordinates.

  Signal:

  - property::y

  ### Type:

  - integer
wibox.width

  The width of the wibox.

  Signal:

  - property::width

  ### Type:

  - width
wibox.height

  The height of the wibox.

  Signal:

  - property::height

  ### Type:

  - height
wibox.screen
  The wibox screen.

  ### Type:

  - screen
wibox.drawable

  The wibox's drawable.

  Signal:

  - property::drawable

  ### Type:

  - drawable drawable
wibox.widget
  The widget that the wibox displays.

  ### Type:

  - widget
wibox.window

  The X window id.

  Signal:

  - property::window

  ### Type:

  - string

  ### See also:

  client.window
wibox.shape_bounding

  The wibox's bounding shape as a (native) cairo surface.

  Signal:

  - *property::shape_bounding*
wibox.shape_clip

  The wibox's clip shape as a (native) cairo surface.

  Signal:

  - *property::shape_clip*
wibox.bg
  The background of the wibox.

  ### Type:

  - c The background to use. This must either be a cairo pattern object, nil or a string that gears.color() understands.

  ### See also:

  gears.color
wibox.bgimage
  The background image of the drawable. If `image` is a function, it will be called with `(context, cr, width, height)` as arguments. Any other arguments passed to this method will be appended.

  ### Type:

  - image A background image or a function

  ### See also:

  gears.surface
wibox.fg
  The foreground (text) of the wibox.

  ### Type:

  - c The foreground to use. This must either be a cairo pattern object, nil or a string that gears.color() understands.

  ### See also:

  gears.color

## Theme variables

beautiful.bg_normal
  The default background color.

  ### See also:

  bg
beautiful.fg_normal
  The default foreground (text) color.

  ### See also:

  fg

## Methods

wibox:buttons (buttons_table)
  Get or set mouse buttons bindings to a wibox.
  - buttons_table A table of buttons objects, or nothing.
wibox:geometry (A)
  Get or set wibox geometry. That's the same as accessing or setting the x, y, width or height properties of a wibox.
  - A table with coordinates to modify.

  ### Returns:

  A table with wibox coordinates and geometry.
wibox:struts (strut)
  Get or set wibox struts.
  - strut A table with new strut, or nothing

  ### Returns:

  The wibox strut in a table.

  ### See also:

  client.struts
wibox:setup (args)
  Set a declarative widget hierarchy description. See The declarative layout system
  - args An array containing the widgets disposition
wibox:find_widgets (x, y)
  Find a widget by a point. The wibox must have drawn itself at least once for this to work.
  - x number X coordinate of the point
  - y number Y coordinate of the point

  ### Returns:

  table A sorted table of widgets positions. The first element is the biggest container while the last is the topmost widget. The table contains x, y, width, height and widget.
wibox:draw (wibox)
  Redraw a wibox. You should never have to call this explicitely because it is automatically called when needed.
  - wibox

generated by LDoc 1.4.6 Last updated 2017-01-20 01:17:18